/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.RestriccionPagoDAO;
import com.rjconsultores.ventaboletos.entidad.ConfigRestriccionPago;
import com.rjconsultores.ventaboletos.entidad.RestriccionPago;
import com.rjconsultores.ventaboletos.service.RestriccionPagoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("restriccionService")
public class RestriccionPagoServiceImpl implements RestriccionPagoService {

    @Autowired
    private RestriccionPagoDAO restriccionDAO;

    public List<RestriccionPago> obtenerTodos() {
        return restriccionDAO.obtenerTodos();
    }

    public RestriccionPago obtenerID(Short id) {
        return restriccionDAO.obtenerID(id);
    }

    @Transactional
    public RestriccionPago suscribir(RestriccionPago entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return restriccionDAO.suscribir(entidad);
    }

    @Transactional
    public RestriccionPago actualizacion(RestriccionPago entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return restriccionDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(RestriccionPago entidad) {
        for (ConfigRestriccionPago crp : entidad.getConfigRestriccionPagoList()) {
            crp.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            crp.setFecmodif(Calendar.getInstance().getTime());
            crp.setActivo(Boolean.FALSE);
        }

        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        restriccionDAO.actualizacion(entidad);
    }
}
